"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = __importDefault(require("fs/promises"));
const ansi_colors_1 = __importDefault(require("ansi-colors"));
const setup_dom_1 = __importDefault(require("./setup-dom"));
const CWD = process.cwd();
async function default_1() {
    if (!(await pathExists(`${CWD}/memserver`))) {
        throw new Error(ansi_colors_1.default.red("/memserver folder doesn't exist for this directory!"));
    }
    else if (!(await pathExists(`${CWD}/memserver/models`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/models folder doesn't exist for this directory!"));
    }
    else if (!(await checkFile(`${CWD}/memserver/routes`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/routes.ts doesn't exist for this directory!"));
    }
    else if (!(await checkFile(`${CWD}/memserver/initializer`))) {
        throw new Error(ansi_colors_1.default.red("/memserver/initializer.ts doesn't exist for this directory!"));
    }
    await setup_dom_1.default();
    window.Memserver = (await Promise.resolve().then(() => __importStar(require("./server")))).default;
    const [initializerModule, routesModule] = await Promise.all([
        Promise.resolve().then(() => __importStar(require(`${CWD}/memserver/initializer`))),
        Promise.resolve().then(() => __importStar(require(`${CWD}/memserver/routes`)))
    ]);
    window.MemServer = new window.Memserver({
        globalizeModels: true,
        initializer: initializerModule.default,
        routes: routesModule.default
    });
    return window.MemServer;
}
exports.default = default_1;
async function checkFile(filePath) {
    return await pathExists(`${filePath}.ts`) || await pathExists(`${filePath}.js`);
}
async function pathExists(path) {
    try {
        await promises_1.default.access(path);
        return true;
    }
    catch {
        return false;
    }
}
